#include "scene.h"
#include "v3.h"
#include "m33.h"
#include <float.h>

#include <iostream>
#include <fstream>

using namespace std;

Scene *scene;

Scene::Scene() {

  // create user interface
  gui = new GUI();
  gui->show();

  // create SW framebuffer
  int u0 = 20;
  int v0 = 50;
  int sci = 2;
  int w = sci*400;
  int h = sci*300;
  fb = new FrameBuffer(u0, v0, w, h);
  fb->label("SW Framebuffer");

  // create camera
  float hfov = 55.0f;
  ppc = new PPC(hfov, w, h);


  fb->show();
  
  // position UI window
  gui->uiw->position(u0, fb->h+v0+60);

}



// function linked to the DBG GUI button for testing new features
void Scene::DBG() {
  fb->Clear(0xFFFFFFFF);
  V3 P0(-20.0f, 0.0f, -100.0f);
  V3 P1(+20.0f, 0.0f, -100.0f);
  fb->Draw3DSegment(P0, P1, 0xFF000000, ppc);
  fb->redraw();
  return;

  V3 v(1.0f, 2.0f, 3.0f);
  v[1] = 13.0f;
  cerr << "v: " << v << endl;
  return;

  unsigned int bgr = 0xFFFFFFFF;
  fb->Clear(bgr);
  fb->redraw();

//  cerr << "INFO: pressed DBG button" << endl;

  return;

}

